﻿using System;
using Fpsware.Library3.Composites;
using Fpsware.Library3.Extensions;
using Fpsware.Library3.Helpers;
using Fpsware.Library3.Utility;
using Styx;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using Misc = Fpsware.Library3.Extensions.Misc;

namespace Fpsware.Botbases.RAFBot2
{
    internal class DeathAndGhost
    {
        #region Local Declarations

        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CT { get { return StyxWoW.Me.CurrentTarget; } }
        private static WoWUnit Pet { get { return StyxWoW.Me.Pet; } }

        #endregion

        internal static Composite CreateDeathAndGhostBehavior()
        {
            return new PrioritySelector(

                // Using Grinder?
                new Decorator(ret => Setting.Instance.UseGrinder.OK(),
                    new PrioritySelector(
                        
                        // Release from our body
                        new Decorator(ret => Me.IsDead && !Me.IsGhost,
                            new Sequence(
                                new Action(context => Log.Info("We're dead! Releasing corpse")),
                                new Action(context => Lua.DoString("RepopMe()"))
                        )),

                        // Retrieve corpse
                        new Decorator( ret => Me.IsGhost && Me.Location.Distance(Me.CorpsePoint) <= 10,
                            new Sequence(
                                new Action(context => Log.Info("Recovering our body")),
                                new Action(context => Lua.DoString("RetrieveCorpse()"))
                        )),

                        // Move to the location of our corpse
                        new Decorator( ret => Me.IsGhost && Me.Location.Distance(Me.CorpsePoint) > 15,
                            new Action(context => Navigator.MoveTo(Me.CorpsePoint)))

                        )),

                // Ghost Run.
                new Decorator(ret => Me.IsGhost && Setting.Instance.MiscGhostRun.OK() && !Library3.Helpers.Misc.IsUserMoving,
                    new PrioritySelector(

                        new Decorator(ret => Me.Location.Distance(Me.CorpsePoint) > 25 && Navigator.CanNavigateFully(Me.Location, Me.CorpsePoint),
                             new PrioritySelector(
                                new ThrottlePasses(1,5, new TreeSharpExt.LogMessage("Navigating to corpse location") ),
                                new Action(context => Navigator.MoveTo(Me.CorpsePoint))
                        ))
                        
                )),
                    

                // Follow the leaders ghost.
                new Decorator(ret => Me.IsGhost && RAFGroup.Leader != null && RAFGroup.Leader.IsGhostVisible,
                    new Movement.MoveTo(ret=> RAFGroup.Leader.Location, ret=> Movement.MovementProviderType.Navigator, ret=> Movement.MountStrategyType.None, ret=> false))

                );
        }

    }
}
