﻿using Fpsware.Library3.Helpers;
using Fpsware.Library3.Utility;
using Styx;
using Styx.CommonBot.POI;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using ActionFail = Fpsware.Library3.Extensions.TreeSharpExt.ActionFail;


namespace Fpsware.Botbases.RAFBot2.Behaviors
{
    public static class PoiBehaviors
    {
        #region Local Declarations
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CT { get { return StyxWoW.Me.CurrentTarget; } }
        private static WoWUnit Pet { get { return StyxWoW.Me.Pet; } }

        #endregion

        public static Composite PoiManagement()
        {
            return new PrioritySelector(
                
                // Make sure we never have a BotPoi of null
                new Decorator(ret => BotPoi.Current == null, new Action(context => { BotPoi.Current = new BotPoi(PoiType.None);})),

                // Assigned a kill target and its no longer valid?
                new Decorator(ret => IsCurrentPoiType(PoiType.Kill) && !Me.Combat, 
                    new ActionFail(
                        context =>
                        {
                            if (BotPoi.Current.AsObject == null || BotPoi.Current.AsObject.ToUnit() == null || !BotPoi.Current.AsObject.ToUnit().IsValidTarget())
                            {
                                Log.FailLog("===== setting BOTPOI to NONE. Our kill target is no longer valid.");
                                BotPoi.Current = new BotPoi(PoiType.None);
                            }
                        }))

                
                );
        }

        public static bool IsPoiFollowLeader
        {
            get
            {
                return BotPoi.Current == null || BotPoi.Current.Type == PoiType.InnKeeper || BotPoi.Current.Type == PoiType.None;
                //return (BotPoi.Current != null || BotPoi.Current != null && BotPoi.Current.AsObject == null || BotPoi.Current.AsObject.ToUnit() == null || !BotPoi.Current.AsObject.ToUnit().IsValidTarget());
            }
        }

        public static bool IsPoiInvalid
        {
            get
            {
                return (BotPoi.Current == null || BotPoi.Current != null && BotPoi.Current.AsObject == null || BotPoi.Current.AsObject.ToUnit() == null || !BotPoi.Current.AsObject.ToUnit().IsValidTarget());
            }
        }


        public static bool IsCurrentPoiType(PoiType poi)
        {
            return BotPoi.Current != null && BotPoi.Current.Type == poi;
        }
    }
}
