﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using Fpsware.Library3.Helpers;
using Fpsware.Library3.Utility;
using Styx.Common;
using Styx.Helpers;
using Styx.WoWInternals;

namespace Fpsware.Botbases.RAFBot2.Helpers
{
    public static class Helpers
    {
        public const string StackLua = @"
            local items={}  
            local done = 1  
            for bag = 0,4 do  
               for slot=1,GetContainerNumSlots(bag) do  
                  local id = GetContainerItemID(bag,slot)  
                  local _,c,l = GetContainerItemInfo(bag, slot)  
                  if id ~= nil then  
                     local n,_,_,_,_,_,_, maxStack = GetItemInfo(id)  
                     if c < maxStack then  
                        if items[id] == nil then  
                           items[id] = {left=maxStack-c,bag=bag,slot=slot,locked = l or 0}  
                        else  
                           if items[id].locked == 0 then  
                              PickupContainerItem(bag, slot)  
                              PickupContainerItem(items[id].bag, items[id].slot)  
                              items[id] = nil  
                           else  
                              items[id] = {left=maxStack-c,bag=bag,slot=slot,locked = l or 0}  
                           end  
                           done = 0  
                        end  
                     end  
                  end  
               end  
            end  
            return done";




        public static void OnRecurrectionHandler(object sender, LuaEventArgs args)
        {
            if (Setting.Instance.AutomationRecurrection.OK())
            {
                Log.Info("Resurrection has been cast on you");
                Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\")");
            }
        }

        public static void OnLfgProposalShow(object obj, LuaEventArgs args)
        {
            if (Setting.Instance.AutomationLFGReady.OK())
            {
                Log.Info("LFG is ready.");
                Lua.DoString("AcceptProposal()");
            }
        }


        public static void OnLfgRoleCheck(object obj, LuaEventArgs args)
        {
            if (Setting.Instance.AutomationLFGReady.OK())
            {
                Log.Info("Automatically accepting role check");
                Lua.DoString("CompleteLFGRoleCheck(true)");
            }
        }

        public static string GetBotPath()
        {
            // taken from Singular.
            string asmName = Assembly.GetExecutingAssembly().GetName().Name;
            int len = asmName.LastIndexOf("_", StringComparison.Ordinal);
            string folderName = asmName.Substring(0, len);

            string botsPath = GlobalSettings.Instance.BotsPath;
            if (!Path.IsPathRooted(botsPath))
            {
                botsPath = Path.Combine(Utilities.AssemblyDirectory, botsPath);
            }
            return Path.Combine(botsPath, folderName);
        }


    }
   

    

}
