﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.WoWInternals.WoWObjects;

namespace Fpsware.Library3.Helpers
{
    public static class Inventory
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        /// <summary>
        /// Checks both specialised bag types and regular bags. A value of 20 might be 10 specialised bags slots free + 10 normal bag slots free
        /// </summary>
        /// <param name="bagType"></param>
        /// <returns></returns>
        public static uint BagSlotsFree(BagType bagType)
        {
            uint freeSlots = 0;

            for (uint i = 0; i < 4; i++)
            {
                if (Me.GetBagAtIndex(i) != null && (Me.GetBagAtIndex(i).BagType == bagType || Me.GetBagAtIndex(i).BagType == BagType.NormalBag))
                {
                    freeSlots += Me.GetBagAtIndex(i).FreeSlots;
                }
            }

            return (freeSlots);
        }

        public static uint HerbBagSlotsFree
        {
            get
            {
                uint freeSlots = 0;

                for (uint i = 0; i < 4; i++)
                {
                    if (Me.GetBagAtIndex(i) != null && (Me.GetBagAtIndex(i).BagType == BagType.HerbBag || Me.GetBagAtIndex(i).BagType == BagType.NormalBag))
                    {
                        freeSlots += Me.GetBagAtIndex(i).FreeSlots;
                    }
                }

                return (freeSlots);
            }
        }

        public static uint MiningBagSlotsFree
        {
            get
            {
                uint freeSlots = 0;

                for (uint i = 0; i < 4; i++)
                {
                    if (Me.GetBagAtIndex(i) != null && (Me.GetBagAtIndex(i).BagType == BagType.MiningBag || Me.GetBagAtIndex(i).BagType == BagType.NormalBag))
                    {
                        freeSlots += Me.GetBagAtIndex(i).FreeSlots;
                    }
                }

                return (freeSlots);
            }
        }

        public static uint SkinningBagSlotsFree
        {
            get
            {
                uint freeSlots = 0;

                for (uint i = 0; i < 4; i++)
                {
                    if (Me.GetBagAtIndex(i) != null && (Me.GetBagAtIndex(i).BagType == BagType.LeatherworkingBag || Me.GetBagAtIndex(i).BagType == BagType.NormalBag))
                    {
                        freeSlots += Me.GetBagAtIndex(i).FreeSlots;
                    }
                }

                return (freeSlots);
            }
        }


        public static int CountOfItemInBags(uint itemID)
        {
            return Me.CarriedItems.Count(i => i.Entry == itemID);
        }

        public static int CountOfItemInBags(List<int> itemIDs, out uint entryID)
        {
            foreach (int i in itemIDs.Where(i => Me.CarriedItems.Any(woWItem => i == woWItem.Entry)))
            {
                entryID = (uint)i;
                return Me.CarriedItems.Count(item => item.Entry == i);
            }

            entryID = 0;
            return 0;
        }

        /// <summary>
        /// Provide a | (pipe) saperated string of items to search for in your inventory. Returns TRUE if anything is found
        /// </summary>
        /// <param name="itemsToSearchFor"></param>
        /// <returns></returns>
        public static bool IsItemInBags(string itemsToSearchFor)
        {
            string[] inventoryItems = itemsToSearchFor.Split('|');

            return inventoryItems.Any(item => Me.CarriedItems.FirstOrDefault(i => i.Name.ToUpper() == item.ToUpper().Trim()) != null);
        }
    }
}
