﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Common;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;
using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using System.Windows.Media;

namespace Fpsware.Library3.Helpers
{
    public static class LogWriter
    {
        private static string _lastMessage;
        private static readonly Stopwatch LogTimer = new Stopwatch();

        public static string PrefixMessage { get; set; }

        private static Color _defaultColour = Colors.DeepSkyBlue;
        public static Color DefaultColour
        {
            get { return _defaultColour; }
            set { _defaultColour = value; }
        }


        public static void Log(string message, params object[] args)
        {
            Log(message, false, args);
        }

        public static void Log(string message, Color messageColor, params object[] args)
        {
            Log(message, messageColor, false, LogLevel.Normal, args);
        }

        public static void Log(string message, bool logFileOnly, params object[] args)
        {
            Log(message, logFileOnly, LogLevel.Normal, args);
        }

        public static void Log(string message, bool logFileOnly = false, LogLevel loggingLevel = LogLevel.Normal, params object[] args)
        {
            Log(message, _defaultColour, logFileOnly, loggingLevel, args);
        }

        public static void Log(string message, Color messageColor, bool logFileOnly, LogLevel loggingLevel, object[] args)
        {
            if (message == null) return;
            if (!LogTimer.IsRunning) LogTimer.Start();
            if (message == _lastMessage && LogTimer.ElapsedMilliseconds < 1500) return;

            if (!logFileOnly)
            {
                // Printed in teh HB log window and log file
                Logging.Write(loggingLevel, messageColor, "{0} {1}", PrefixMessage, string.Format(message, args));
            }
            else
            {
                // Only printed in the HB log file.
                Logging.WriteToFileSync(loggingLevel, "{0} {1}", PrefixMessage + " Debug", string.Format(message, args));
            }

            _lastMessage = message;
            LogTimer.Reset();
        }

    }
}
