﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using Fpsware.Library3.Utility;
using Styx;
using Styx.CommonBot.Frames;
using Styx.WoWInternals.WoWObjects;
using System;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace Fpsware.Library3.Helpers
{
    public static class Misc
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CT { get { return StyxWoW.Me.CurrentTarget; } }
        private static WoWUnit Pet { get { return StyxWoW.Me.Pet; } }

        public static void CloseAllNpcFrames()
        {
            if (AuctionFrame.Instance.IsVisible) { AuctionFrame.Instance.Close(); }
            if (GossipFrame.Instance.IsVisible) { GossipFrame.Instance.Close(); }
            if (MailFrame.Instance.IsVisible) { MailFrame.Instance.Close(); }
            if (MerchantFrame.Instance.IsVisible) { MerchantFrame.Instance.Close(); }
            if (QuestFrame.Instance.IsVisible) { QuestFrame.Instance.Close(); }
            if (TaxiFrame.Instance.IsVisible) { TaxiFrame.Instance.Close(); }
            if (TrainerFrame.Instance.IsVisible) { TrainerFrame.Instance.Close(); }
        }


        public static string GetBotPath()
        {
            // taken from Singular.
            try
            {
                string asmName = Assembly.GetExecutingAssembly().GetName().Name;
                //Log.FocusLog("=== asmName: " + asmName);
                int len = asmName.LastIndexOf("_", StringComparison.Ordinal);
                //Log.FocusLog("=== len: " + len);
                string folderName = asmName.Substring(0, len);
                //Log.FocusLog("=== folderName: " + folderName);

                string botsPath = GlobalSettings.Instance.BotsPath;
                if (!Path.IsPathRooted(botsPath))
                {
                    botsPath = Path.Combine(Utilities.AssemblyDirectory, botsPath);
                }
                return Path.Combine(botsPath, folderName);
            }
            catch (Exception e)
            {
                Log.FailLog("=== ah shit, GetBotPath() failed!");
                Log.FailLog(e.Message);

                Log.FailLog(e.Message);
            }

            return null;
        }

        public static bool IsClosedSource
        {
            get
            {
                string asmName = Assembly.GetExecutingAssembly().GetName().Name;
                int len = asmName.LastIndexOf("_", StringComparison.Ordinal);
                return len <= 0;
            }
        }


        public static bool IsUserMoving
        {
            get
            {
                // if the current WoW window does not have focus then ignore the [global] keydown overrides
                if (StyxWoW.Memory.Process.Id != KeyboardPolling.ForegroundWindowPid) return false;

                if (KeyboardPolling.IsKeyDown(Keys.W)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.S)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.A)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.D)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.Q)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.E)) return true;

                if (KeyboardPolling.IsKeyDown(Keys.Left)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.Right)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.Up)) return true;
                if (KeyboardPolling.IsKeyDown(Keys.Down)) return true;

                if (KeyboardPolling.IsKeyDown(Keys.LButton) && KeyboardPolling.IsKeyDown(Keys.RButton)) return true;

                return false;
            }
        }



        public static bool IsThisMyComputer(string computernames)
        {
            string[] computerName = computernames.Split('|');
            string currentComputerName = System.Security.Principal.WindowsIdentity.GetCurrent().Name.ToUpper();

            return computerName.Any(s => currentComputerName.ToUpper().Contains(s.Trim().ToUpper()));
        }


        public static void UpdateFpswareLibFromSVN()
        {
            SvnUpdater svnUpdater = new SvnUpdater
            {
                Repository = SvnUpdater.RepositoryType.Assembla,
                SVNProject = "ZgBwAHMAdwBhAHIAZQAtAGwAaQBiAHIAYQByAHkALQAyAA==".Base64Decode(),
                DownloadPath = GetBotPath(),
                NameOfDownload = "RgBwAHMAdwBhAHIAZQAgAEwAaQBiAHIAYQByAHkAIABWADIA".Base64Decode(),
                SilentChanngeLog = false,
                SilentDownloading = true,
                ForcedUpdate = true
            };

            svnUpdater.AutoUpdate();
        }

        public static string Base64Decode(this string encodedString)
        {
            string result = Encoding.Unicode.GetString(Convert.FromBase64String(encodedString));
            return result;
        }

        public static string Base64Encode(this string rawString)
        {
            string result = Convert.ToBase64String(Encoding.Unicode.GetBytes(rawString));
            return result;
        }


    }




    public class KeyboardPolling
    {
        [DllImport("user32.dll")]
        private static extern short GetAsyncKeyState(Keys vKey);

        public static bool IsKeyDown(Keys key) { return (GetAsyncKeyState(key)) != 0; }

        public static bool IsKeyUp(Keys key) { return (GetAsyncKeyState(key)) == 0; }

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        [DllImport("user32.dll", SetLastError = true)]
        public static extern int GetWindowThreadProcessId(IntPtr hWnd, out int lpdwProcessId);

        public static int ForegroundWindowPid
        {
            get
            {
                int processID = 0;
                int threadID = GetWindowThreadProcessId(GetForegroundWindow(), out processID);
                return processID;
            }
        }
    }
}
