﻿using System.Text;
using System.IO;
using System.Runtime.Serialization;
using System.Xml;

namespace Fpsware.Library3.Helpers
{
    public static class Serialize
    {
        public static void Seralize<T>(this T obj, string fileName)
        {
            DataContractSerializer serializer = new DataContractSerializer(obj.GetType());
            MemoryStream memoryStream = new MemoryStream();
            serializer.WriteObject(memoryStream, obj);

            XmlDocument xmlDocument = new XmlDocument();
            memoryStream.Position = 0;
            xmlDocument.Load(memoryStream);
            xmlDocument.Save(fileName);
        }

        public static T Deserialize<T>(string fileName)
        {
            XmlDocument xmlDocument = new XmlDocument();
            xmlDocument.Load(fileName);
            string xml = xmlDocument.InnerXml;

            using (MemoryStream memoryStream = new MemoryStream(Encoding.UTF8.GetBytes(xml)))
            {
                XmlDictionaryReader reader = XmlDictionaryReader.CreateTextReader(memoryStream, Encoding.UTF8, new XmlDictionaryReaderQuotas(), null);
                DataContractSerializer serializer = new DataContractSerializer(typeof(T));
                return (T)serializer.ReadObject(reader);
            }
        }

    }
}
