﻿using Styx;
using Styx.Common;
using Styx.Helpers;

namespace Fpsware.Botbases.RAFBot2
{
    class GlobalSetting : Settings
    {
        private static GlobalSetting _instance;
        public GlobalSetting() : base(SettingsPath + ".xml") { }
        public GlobalSetting(string settingsPath) : base(settingsPath) { }
        private static string SettingsPath { get { return string.Format("{0}\\Settings\\Fpsware RAF Bot\\GlobalSettings", Utilities.AssemblyDirectory); } }
        public static GlobalSetting Instance { get { return _instance ?? (_instance = new GlobalSetting()); } }


        [Setting, DefaultValue("Disabled")]
        public string AutoUpdate { get; set; }
        
        [Setting, DefaultValue("Blazing Cleave [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147702,MobID:72895,Degrees:360,Distance:6] Action[RunToDistance:7]|Breath of Fire [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147416,MobID:72875,Degrees:90,Distance:10] Action[MoveBehindCaster]|Burning Fury [CheckAgainst:Aura,SourceTarget:IsTargetingMe,SpellID:147703,MobID:72895,Distance:15] Action[RunToDistance:20]|Burning Fury [CheckAgainst:SpellCast,SourceTarget:IsTargetingMe,SpellID:147703,MobID:72895,Degrees:0,Distance:15] Action[RunToDistance:20]|Cracking Blow [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147674,MobID:72892,Degrees:100,Distance:20] Action[MoveBehindCaster]|Defensive Shield [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:147689,MobID:72892,Degrees:180,Distance:40] Action[MoveBehindCaster]|Devastating Arc [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:124946,MobID:50359,Degrees:180,Distance:20] Action[RunToDistance:25]|Greater Swipe [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147652,MobID:72805,Degrees:130,Distance:10] Action[MoveBehindCaster]|Gust of Wind [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147310,MobID:72762,Degrees:130,Distance:10] Action[MoveBehindCaster]|Ox Charge [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147385,MobID:72844,Degrees:130,Distance:12] Action[RunToDistance:15]|Rending Swipe [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147646,MobID:72807,Degrees:130,Distance:8] Action[MoveBehindCaster]|Shell Spin [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147571,MobID:72764,Degrees:360,Distance:15] Action[RunToDistance:20]|Spinning Crane Kick [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:148730,MobID:73018,Degrees:360,Distance:10] Action[RunToDistance:13]|Spiritflame Strike [CheckAgainst:SpellCast,SourceTarget:AnyHostileNearBy,SpellID:147448,MobID:73162,Degrees:360,Distance:20] Action[RunToDistance:30]|Thunder Crush [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:138044,MobID:69768,Degrees:170,Distance:21] Action[RunToDistance:25]|Vengeful Spirit [CheckAgainst:Mob,SourceTarget:IsTargetingMe,MobID:69806,Distance:15] Action[RunToDistance:35]|Vengeful Spirit [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:138043,MobID:69768,Degrees:360,Distance:25] Action[RunToDistance:30]|Voidcloud [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:125241,MobID:50344,Degrees:360,Distance:20] Action[RunToDistance:35]|Whirling Flame [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:125985,MobID:63695,Degrees:120,Distance:12] Action[RunToDistance:15]|Yaungol Stomp [CheckAgainst:SpellCast,SourceTarget:IsMyCurrentTarget,SpellID:124289,MobID:50332,Degrees:360,Distance:8] Action[RunToDistance:10]")]
        public string EncounterLogic { get; set; }
        
    }
}
