﻿using System;
using System.Windows.Forms;
using Fpsware.Library3.Helpers;

namespace Fpsware.Botbases.RAFBot2.UI
{
    public partial class UIUpdateInfo : Form
    {
        private readonly SvnUpdater _svnUpdater = new SvnUpdater();
        private string _updateLog;

        public UIUpdateInfo()
        {
            InitializeComponent();

            _svnUpdater.Repository = SvnUpdater.RepositoryType.Assembla;
            _svnUpdater.SVNProject = "ZgBwAHMAdwBhAHIAZQAtAHIAYQBmAC0AYgBvAHQA".Base64Decode();
            _svnUpdater.DownloadPath = Helpers.Helpers.GetBotPath();
            _svnUpdater.NameOfDownload = "RgBwAHMAdwBhAHIAZQAgAFIAQQBGACAAQgBvAHQA".Base64Decode();
            _svnUpdater.SilentChanngeLog = true;

            if (!_svnUpdater.IsUpdateAvailable)
            {
                Close();
            }
            else
            {
                UpdateLog = _svnUpdater.ChangeLog;
                
                ucBuildNumber.Value = _svnUpdater.OnlineRevision;
                ucLastUpdated.Value = _svnUpdater.LastUpdated;
            }
        }

        public string UpdateLog
        {
            set
            {
                _updateLog = value;
                richTextBox1.Text = _updateLog;
            }
        }

        private void btnCancel_Click(object sender, EventArgs e) { Close(); }

        private void UIUpdateInfo_Load(object sender, EventArgs e)
        {
            
        }

    }
}
