﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Fpsware.Library3.Helpers;
using Fpsware.Library3.Utility;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;

namespace Fpsware.Botbases.RAFBot2.Helpers
{
    public static class Hotkeys
    {
        public static bool Registered { get; set; }
        public static Keys KeyBinding(string setting)
        {
            if (setting.Contains("None")) return Keys.None;

            if (Enum.IsDefined(typeof(Keys), setting))
            {
                return (Keys)Enum.Parse(typeof(Keys), setting);
            }

            // If all else fails just reutrn None
            return Keys.None;
        }

        private static ModifierKeys KeyBindingModifier(string setting)
        {
            if (setting.Contains("None") || setting.Contains("NoRepeat")) return ModifierKeys.NoRepeat;

            if (Enum.IsDefined(typeof(ModifierKeys), setting))
            {
                return (ModifierKeys)Enum.Parse(typeof(ModifierKeys), setting);
            }

            // If all else fails just reutrn None
            return ModifierKeys.NoRepeat;
        }


        public static void UnregisterHotkeys()
        {
            Registered = false;
            Log.Info("Unregistering all hotkeys");

            HotkeysManager.Unregister("Grinder Toggle");
            HotkeysManager.Unregister("Advanced Questing Toggle");

        }

        public static void RegisterHotkeys()
        {
            if (Registered) return;

            HotkeysManager.Register("Grinder Toggle", KeyBinding(Setting.Instance.KeyToggleGrinder), KeyBindingModifier(Setting.Instance.KeyToggleGrinderMod), ToggleGrinder);
            HotkeysManager.Register("Advanced Questing Toggle", KeyBinding(Setting.Instance.KeyToggleAdvancedQuesting), KeyBindingModifier(Setting.Instance.KeyToggleAdvancedQuestingMod), ToggleAdvancedQuesting);
            
            Registered = true;
        }

        //private static string _tempTargetingValue;
        private static void ToggleGrinder(Hotkey obj)
        {
            switch (Setting.Instance.UseGrinder)
            {
                case "Disabled":
                    Setting.Instance.UseGrinder = "Enabled";
                    if (Setting.Instance.MiscWoWMessages.OK()) Lua.DoString(@"print('Grinder \124cFF15E61C ENABLED!')");
                    Log.Info("Grinder ENABLED");
                    break;

                case "Enabled":
                    Setting.Instance.UseGrinder = "Disabled";
                    if (Setting.Instance.MiscWoWMessages.OK()) Lua.DoString(@"print('Grinder \124cFFE61515 DISABLED!')");
                    Log.Info("Grinder DISABLED");
                    break;
            }
        }

        private static void ToggleAdvancedQuesting(Hotkey obj)
        {
            switch (Setting.Instance.QuestUseAdvancedFeatures)
            {
                case "Disabled":
                    Setting.Instance.QuestUseAdvancedFeatures = "Enabled";
                    if (Setting.Instance.MiscWoWMessages.OK()) Lua.DoString(@"print('Advanced Questing Features \124cFF15E61C ENABLED!')");
                    Log.Info("Advanced Questing Features ENABLED");
                    break;

                case "Enabled":
                    Setting.Instance.QuestUseAdvancedFeatures = "Disabled";
                    if (Setting.Instance.MiscWoWMessages.OK()) Lua.DoString(@"print('Advanced Questing Features \124cFFE61515 DISABLED!')");
                    Log.Info("Advanced Questing Features DISABLED");
                    break;
            }
        }

        

    }
}
