﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Windows.Forms.VisualStyles;
using Styx;
using Styx.WoWInternals.WoWObjects;

namespace Fpsware.Botbases.RAFBot2.UI
{
    public partial class UIInventoryItems : Form
    {
        public UIInventoryItems() { InitializeComponent(); }

        public string SelectedInventoryItem { get; set; }
        private bool _listPopulated;
        private void UINewEncounterLogic_Load(object sender, EventArgs e)
        {
            timer1.Start();
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            foreach (var item in clbInventory.CheckedItems)
            {
                if (!string.IsNullOrEmpty(SelectedInventoryItem))
                {
                    if (!string.IsNullOrEmpty(item.ToString()))
                        SelectedInventoryItem += SelectedInventoryItem.EndsWith("|") ? item.ToString() : "|" + item;
                }
                else
                {
                    if (!string.IsNullOrEmpty(item.ToString()))
                        SelectedInventoryItem = item.ToString();
                }
            }

            DialogResult = DialogResult.OK;
        }


        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (_listPopulated) return;

            try
            {
                string[] autoDeleteInventory = Setting.Instance.AutoDeleteItems.Split('|');
                List<WoWItem> inventoryItems = StyxWoW.Me.CarriedItems.Where(i => !autoDeleteInventory.Contains(i.Name) && (i.Quality == WoWItemQuality.Poor || i.Quality == WoWItemQuality.Uncommon || i.Quality == WoWItemQuality.Common)).ToList();

                foreach (WoWItem item in inventoryItems.Where(i => !clbInventory.Items.Contains(i.Name)))
                {
                    if (string.IsNullOrEmpty(item.Name)) continue;
                    clbInventory.Items.Add(item.Name);
                }
                
                _listPopulated = true;
                clbInventory.Enabled = true;
                btnAdd.Enabled = true;
                //ucInventoryItem.SelectFirstItem();

                timer1.Stop();
                timer1.Enabled = false;
                lblWaitMessage.Visible = false;
            }
            catch (Exception exception) { }
        }
    }
}
