﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Fpsware.Library3.Utility;
using Styx;
using Styx.WoWInternals;

namespace Fpsware.Botbases.RAFBot2.UI
{
    public partial class UITargetsAuras : Form
    {
        public UITargetsAuras() { InitializeComponent(); }

        public string SelectedItem { get; set; }
        private bool _listPopulated;

        private void btnAdd_Click(object sender, EventArgs e) { DialogResult = DialogResult.OK; }

        private void btnCancel_Click(object sender, EventArgs e) { DialogResult = DialogResult.Cancel; }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (_listPopulated) return;

            try
            {
                if (StyxWoW.Me.GotTarget)
                {
                    foreach (KeyValuePair<string, WoWAura> aura in StyxWoW.Me.CurrentTarget.Auras)
                    {
                        clbAuras.Items.Add(string.Format("{0} [{1}]", aura.Key, aura.Value.SpellId));
                    }
                }

                _listPopulated = true;
                clbAuras.Enabled = true;
                btnAdd.Enabled = true;
                //ucInventoryItem.SelectFirstItem();

                timer1.Stop();
                timer1.Enabled = false;
                lblWaitMessage.Visible = false;
                Text = string.Format("{0}'s Auras", StyxWoW.Me.CurrentTarget.Name);
            }
            catch (Exception exception) { }
        }

        private void UITargetsAuras_Load(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void clbAuras_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            SelectedItem = clbAuras.SelectedItem.ToString();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            clbAuras.Items.Clear();
            lblWaitMessage.Visible = true;

            if (StyxWoW.Me.GotTarget)
            {
                foreach (KeyValuePair<string, WoWAura> aura in StyxWoW.Me.CurrentTarget.Auras)
                {
                    clbAuras.Items.Add(string.Format("{0} [{1}]", aura.Key, aura.Value.SpellId));
                }

                Text = string.Format("{0}'s Auras", StyxWoW.Me.CurrentTarget.Name);
            }

            lblWaitMessage.Visible = false;
        }
    }
}
