﻿using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using Fpsware.Library3.Utility;

namespace Fpsware.Botbases.RAFBot2.UI
{
    public partial class UITrigger : Form
    {
        public UITrigger() { InitializeComponent(); }

        private bool _isNewEncounter = true;
        int defaultHeigh = 146;

        //public GrinderActionTrigger.ActionTrigger ActionTrigger { get; set; }
        public string ActionTrigger { get; set; }

        private void UINewEncounterLogic_Load(object sender, EventArgs e)
        {
            treeActionTrigger.ExpandAll();

            if (ActionTrigger != null && !string.IsNullOrEmpty(ActionTrigger))
            {
                GrinderActionTrigger.ActionTrigger action = new GrinderActionTrigger.ActionTrigger(ActionTrigger);
                ucActionTaken.Value = action.Action;
                TreeNode triggerNodesParent = treeActionTrigger.Nodes["Triggers"];

                foreach (GrinderActionTrigger.TriggerCondition trigger in action.Triggers)
                {
                    StringBuilder sb = new StringBuilder();    
                    //sb.AppendFormat("[{0}:", trigger.Event);

                    if (trigger.Event == "ItemCount")
                    {
                        sb.AppendFormat("[{2}:{0}#{1}]", trigger.Name, trigger.Quantity,trigger.Event);
                    }
                    else
                    {
                        sb.AppendFormat("[{0}:{1}]", trigger.Event, trigger.Quantity);
                    }

                    triggerNodesParent.Nodes.Add(sb.ToString());
                }

                treeActionTrigger.ExpandAll();
                btnAdd.Text = "Update";

            }
            else
            {
                ActionTrigger = "";
            }

            ResizeTree();

        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            if (treeActionTrigger.Nodes["Triggers"].Nodes.Count > 0)
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("Trigger(");

                foreach (TreeNode node in treeActionTrigger.Nodes["Triggers"].Nodes)
                {
                    if (sb.ToString().EndsWith("]")) sb.AppendFormat(" {0} ", "_AND_");
                    sb.AppendFormat("{0}", node.Text);
                }

                sb.AppendFormat(") Action({0})", ucActionTaken.Value);
                
                
                ActionTrigger = sb.ToString();

            }


            DialogResult = DialogResult.OK;
        }



        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }

        private void ResizeTree()
        {
            if (ucActionTaken.Value == "Return Home" && String.IsNullOrEmpty(Setting.Instance.HomeLocation))
            {
                if (!lblHomeLocationWarning.Visible)
                {
                    lblHomeLocationWarning.Visible = true;
                    treeActionTrigger.Height = (defaultHeigh - lblHomeLocationWarning.Height);
                }
                //MessageBox.Show("In order to properly use this action you must set your home location.\n\nThis can be done on the Miscelaneous tab in the UI", "Home Location Not Set", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if (lblHomeLocationWarning.Visible)
                {
                    lblHomeLocationWarning.Visible = false;
                    treeActionTrigger.Height = defaultHeigh;
                }
            }

            this.Refresh();
        }


        private void ucActionTaken_ValueChangedOther(object sender, Library3.UI.DropdownValueChangedEventArgs e)
        {
            treeActionTrigger.Nodes["Action"].Nodes[0].Text = ucActionTaken.Value;
         
            ResizeTree();
        }

        private void btnAddTrigger_Click(object sender, EventArgs e)
        {
            TreeNode newTrigger = new TreeNode();

            switch (ucEvent.Value)
            {
                case "ItemCount":
                    if (string.IsNullOrEmpty(ucName.Value) || ucQuantity.Value == 0)
                    {
                        MessageBox.Show("Trigger criteria is not valid. Complete all required fields", "Invalid Trigger", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }

                    newTrigger.Text = string.Format("[{0}:{1}#{2}]", ucEvent.Value, ucName.Value, ucQuantity.Value);
                    break;

                default:
                    if (ucQuantity.Value == 0)
                    {
                        MessageBox.Show("Quantity value can not be 0", "Invalid Trigger", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    newTrigger.Text = string.Format("[{0}:{1}]", ucEvent.Value, ucQuantity.Value);
                    break;
            }

            btnUpdate.Visible = false;
            //ucEvent.Value = "ItemCount";
            //ucQuantity.Value = 0;
            //ucActionCriteria.Value = "";
            treeActionTrigger.HideSelection = true;

            /*
            if (ucEvent.Value == "ItemCount")
            {
                if (string.IsNullOrEmpty(ucName.Value) || ucQuantity.Value == 0)
                {
                    MessageBox.Show("Trigger criteria is not valid. Complete all required fields", "Invalid Trigger", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                newTrigger.Text = string.Format("[{0}:{1}#{2}]", ucEvent.Value, ucName.Value, ucQuantity.Value);
            }
            else
            {
                if (ucQuantity.Value == 0)
                {
                    MessageBox.Show("Quantity value can not be 0", "Invalid Trigger", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                newTrigger.Text = string.Format("[{0}:{1}]", ucEvent.Value, ucQuantity.Value);
            }
             */

            treeActionTrigger.Nodes["Triggers"].Nodes.Add(newTrigger);
            treeActionTrigger.ExpandAll();
        }

        private void contextMenuStrip1_Opening(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (treeActionTrigger.SelectedNode == null) e.Cancel = true;

            if (treeActionTrigger.SelectedNode.Name == "Triggers" || treeActionTrigger.SelectedNode.Name == "Action" || treeActionTrigger.SelectedNode.Parent.Name == "Action")
            {
                //removeSelectedTriggerToolStripMenuItem.Enabled = false;
                e.Cancel = true;
            }
            else
            {
                removeSelectedTriggerToolStripMenuItem.Enabled = true;
            }
        }

        private void removeSelectedTriggerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            treeActionTrigger.Nodes.Remove(treeActionTrigger.SelectedNode);

            btnUpdate.Visible = false;
            ucEvent.Value = "ItemCount";
            ucQuantity.Value = 0;
            ucActionCriteria.Value = "";
            treeActionTrigger.HideSelection = true;
        }

        private void ucEvent_ValueChangedOther(object sender, Library3.UI.DropdownValueChangedEventArgs e)
        {
            ucName.Enabled = ucEvent.Value == "ItemCount";
            ucQuantity.Label = (ucEvent.Value == "ElapsedMinutes" ? "Minutes" : "Quantity");
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            btnAdd.Enabled = treeActionTrigger.Nodes["Triggers"].Nodes.Count > 0;
        }

        private void ucActionTaken_Load(object sender, EventArgs e)
        {

        }

        private void treeActionTrigger_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            if (e.Node.Parent != null && e.Node.Parent.Name == "Triggers" && e.Button == MouseButtons.Left)
            {
                if (e.Node.Text.Contains("ItemCount"))
                {
                    ucEvent.Value = "ItemCount";
                    
                    string s = e.Node.Text;
                    string name = Regex.Match(s, @"(?<=\:)[^)]*?(?=\#)", RegexOptions.IgnoreCase).Value;
                    string quantityTemp = Regex.Match(s, @"(?<=\#)\d*(?=\])").Value;
                    int quantity = Convert.ToInt16(quantityTemp);

                    ucActionCriteria.Value = name;
                    ucQuantity.Value = quantity;

                }
                else if (e.Node.Text.Contains("ElapsedMinutes"))
                {
                    ucEvent.Value = "ElapsedMinutes";
                    
                    string s = e.Node.Text;
                    string quantityTemp = Regex.Match(s, @"(?<=\:)\d*(?=\])").Value;
                    int quantity = Convert.ToInt16(quantityTemp);
                    
                    ucQuantity.Value = quantity;
                }

                btnUpdate.Visible = true;
                btnUpdate.Enabled = true;
                treeActionTrigger.HideSelection = false;
            }
            else
            {
                btnUpdate.Visible = false;
                ucEvent.Value = "ItemCount";
                ucQuantity.Value = 0;
                ucActionCriteria.Value = "";
                treeActionTrigger.HideSelection = true;
            }
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            TreeNode selectedNode = treeActionTrigger.SelectedNode;

            switch (ucEvent.Value)
            {
                case "ItemCount":
                    if (string.IsNullOrEmpty(ucName.Value) || ucQuantity.Value == 0)
                    {
                        MessageBox.Show("Trigger criteria is not valid. Complete all required fields", "Invalid Trigger", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }

                    selectedNode.Text = string.Format("[{0}:{1}#{2}]", ucEvent.Value, ucName.Value, ucQuantity.Value);
                    break;

                default:
                    if (ucQuantity.Value == 0)
                    {
                        MessageBox.Show("Quantity value can not be 0", "Invalid Trigger", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    selectedNode.Text = string.Format("[{0}:{1}]", ucEvent.Value, ucQuantity.Value);
                    break;
            }

            btnUpdate.Visible = false;
            ucEvent.Value = "ItemCount";
            ucQuantity.Value = 0;
            ucActionCriteria.Value = "";
            treeActionTrigger.HideSelection = true;
        }
    }
}
